# ---- coding: utf-8 --
###########################################################################
##################### By:subixonfire  www.satforum.me #####################
###########################################################################
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from enigma import eServiceReference, eConsoleAppContainer, ePicLoad, getDesktop, eServiceCenter
from Components.MenuList import MenuList
from Screens.MessageBox import MessageBox
from Components.ActionMap import ActionMap
from Components.ScrollLabel import ScrollLabel
import urllib, urllib2, re, time, os
from enigma import eDVBDB

     

###########################################################################


                         
###########################################################################
class E2ChLists(Screen):
    wsize = getDesktop(0).size().width()
    hsize = getDesktop(0).size().height()
    plugin_dir = os.path.dirname(os.path.realpath(__file__)) + "/"
    
    skin = """
        <screen flags="wfNoBorder" position="0,0" size=\"""" + str(wsize) + "," + str(hsize) + """\" title="Odaberite listu" >
        <ePixmap alphatest="on" pixmap=\"""" + plugin_dir + """main.png" position="0,0" size=\"""" + str(wsize) + "," + str(hsize) + """\"  zPosition="-2"/>
        <widget name="myMenu" position="80,180" size=\"""" + str(wsize - 160) + "," + str(hsize - 260) + """\" scrollbarMode="showOnDemand" transparent="1" />
        <ePixmap pixmap=\"""" + plugin_dir + """barra470.png" position="1175,175" size="29,468" alphatest="blend" zPosition="4" transparent="1"/>
        </screen>"""
    
    theFunc = "main"
    osdList = []
    historyList = []
    historyInt = 0        
        
        
    def __init__(self, session):
        
        def gethtml(url, data =''):
            try:
                req = urllib2.Request(url)
                req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3 Gecko/2008092417 Firefox/3.0.3')
                if data == '':
                    response = urllib2.urlopen(req)
                else:
                    response = urllib2.urlopen(req, data)     
                htmldoc = str(response.read())
                response.close()
                return htmldoc 
            except :
                print "jebiga gethtml" 
        
    
        home = "http://dream500s.info/settings/liste/"
    
        html = gethtml(home)
        links = re.compile ('<li><a href="([0-9a-zA-Z@]*?/)"> (.+?)/</a></li>', re.DOTALL).findall(html)
    
        self.oldlist = self.osdList
        self.osdList = []
        
        for link in links:
            linkx = home + link[0]
            if not link[1] == "SplitThisList":
                self.osdList.append((link[1].title(), linkx))
        
                            
        
        Screen.__init__(self, session)
        self["myMenu"] = MenuList(self.osdList)
        self["myActionMap"] = ActionMap(["SetupActions", "EPGSelectActions"],
        {
        "ok": self.go,
        "info": self.info,
        "cancel": self.cancel
        }, 
        -1)    
        
    
    def go(self):
        returnValue = self["myMenu"].l.getCurrentSelection()[1]
        print returnValue
        returnSelection = self["myMenu"].l.getCurrentSelection()[0]
        returnIndex = self["myMenu"].getSelectedIndex()
        
        def gethtml(url, data =''):
            #print "url  ", url
            try:
                req = urllib2.Request(url)
                req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3 Gecko/2008092417 Firefox/3.0.3')
                if data == '':
                    response = urllib2.urlopen(req)
                else:
                    response = urllib2.urlopen(req, data)     
                htmldoc = str(response.read())
                response.close()
                return htmldoc 
            except :
                print "jebiga gethtml"
        
        if not self.theFunc == "install":
            try:
                self.historyList[int(self.historyInt)] = [self.theFunc, self.osdList, returnIndex]
            except:    
                self.historyList.append([self.theFunc, self.osdList, returnIndex])
            self.historyInt = self.historyInt + 1
        
        
        if self.theFunc == "main":
            #print returnValue 
            #print returnSelection
            home = returnValue
            html = gethtml(returnValue)
            links = re.compile ('<li><a href="([%0-9a-zA-Z@]*?/)"> (.+?)/</a></li>').findall(html)
            
            self.oldlist = self.osdList
            self.osdList = []
        
            for link in links:
                linkx = home + link[0]
                self.osdList.append((link[1].title(), linkx))
            
            #print self.osdList
            
            self["myMenu"].setList(self.osdList)
            
            self.theFunc = "type"
            
        elif self.theFunc == "type":
            #print returnValue 
            #print returnSelection
            home = returnValue
            html = gethtml(returnValue)
            #links = re.compile ('<li><a href="([%0-9a-zA-Z@]*?/)"> (.+?)/</a></li>').findall(html)
            links = re.compile ('<li><a href="(.+?[zip/rar])"> (.+?)</a></li>').findall(html)
            print links
            
            self.oldlist = self.osdList
            self.osdList = []
        
            for link in links:
                linkx = home + link[0]
                #html = gethtml(linkx)
                #links2 = re.compile ('<li><a href="(.+?[zip/rar])"> (.+?)</a></li>').findall(html)
                if (link[1].find("E2") > -1 ):
                    self.osdList.append((link[1].title(), linkx))
                #for link2 in links2:
                    #if (link2[1].find("E2") > -1 ):
                        #linkz = linkx + link2[0]
                        #print linkz
                        #self.osdList.append((link2[1].title(), linkz))
            
            #print self.osdList
            
            self["myMenu"].setList(self.osdList)
            
            self.theFunc = "install"
        
        elif self.theFunc == "install":
        
            #download zip/rar file from internet
            tmpfile = "/tmp/e2chlist_tmp" + returnValue[-4:]
            os.system( "wget \"" + returnValue + "\" -O " + tmpfile )
        
            #unzip/unrar file to tmp dir
            os.system("mkdir /tmp/e2chlist_tmp")
            os.system("rm /tmp/e2chlist_tmp/*")
            if returnValue[-3:].upper() == "ZIP":
                os.system( "unzip \"" + tmpfile + "\" -d \"/tmp/e2chlist_tmp\"")
            elif returnValue[-3:].upper() == "RAR":
                os.system( "unrar e \"" + tmpfile + "\"  \"/tmp/e2chlist_tmp\"")   
        
        
            #delete old userbouquets
            os.system("rm /etc/enigma2/userbouquet.*")
        
            #move files to place
            os.system("mv -f /tmp/e2chlist_tmp/* /etc/enigma2/")
            os.system("mv -f /etc/enigma2/satellites.xml /etc/tuxbox/satellites.xml")
            os.system("mv -f /etc/enigma2/terestrial.xml /etc/tuxbox/terestrial.xml")
        
            #reboot e2
            #os.system("killall -9 enigma2")
        
            eDVBDB.getInstance().reloadServicelist()
            eDVBDB.getInstance().reloadBouquets()    
        
            self.session.open(MessageBox, _("List downloaded and installed..."), type = MessageBox.TYPE_INFO,timeout = 7 )
         
            self.close(False, self.session)            
    
    def cancel(self):
        print self.theFunc
        if self.historyInt > 0:
            self.historyInt = self.historyInt - 1
            self.theFunc = self.historyList[self.historyInt][0]
            self.osdList = self.historyList[self.historyInt][1]
            self["myMenu"].setList(self.osdList)
            self["myMenu"].moveToIndex(self.historyList[self.historyInt][2])
            
            print "#################### radiiiiii "
            
        else:    
            self.close(None)
        
    def info(self):
        info = "E2 Ex YU settings panel \n\nVerzija: b4f\nDatum izrade: 19.04.2013. godine\n\nHvala svima koji su učestvovali u projektu:\n- subixonfire / izrada plugina.\n- beli@1910 / ideja i realizacija.\n- mlad / beta tester plugina.\n- Daconi / grafička riješenja i design.\n- SATmax / web stranica, server, izmijene lista ...\n- Autorima lista: Don@, Predr@g, ciefp, ...\n\n Info web stranica:\nhttp://dream500s.info/settings\n\nSva prava pridržana suradnika na projektu."
        self.session.open(MessageBox, _(info), type = MessageBox.TYPE_INFO,timeout = 10 )    
        
         
###########################################################################

###########################################################################

def main(session, **kwargs):

    burek = session.open(E2ChLists)
    
                  
def Plugins(**kwargs):
    return PluginDescriptor(
        name="E2 Ex YU settings panel",
        description="E2 Ex YU settings panel",
        where = [ PluginDescriptor.WHERE_EXTENSIONSMENU, PluginDescriptor.WHERE_PLUGINMENU ],
        icon="./icon.png",
        fnc=main)


